<template>
  <div class="resource-form-container">
    <b-card no-body>
      <b-tabs card>
        <!-- <b-tab
          :key="`${usedFor}-bd-tab-${bdKey}`"
          title="Base de données"
          active
          ref="bdResourceTab"
          @click="fileKey += 1; ftpKey += 1; hrefKey += 1; isRequired = false"
        >
          <b-card-text>
            <BDResourceCreator
              v-if="$refs.bdResourceTab"
              :required="$refs.bdResourceTab.localActive && isRequired"
              :usedFor="usedFor"
              @set="setForm"
            />
          </b-card-text>
        </b-tab> -->
        <b-tab
          :key="`${usedFor}-file-tab-${fileKey}`"
          title="Charger un fichier"
          ref="fileResourceTab"
          @click="bdKey +=1; ftpKey += 1; hrefKey += 1; isRequired = false"
        >
          <b-card-text>
            <FileUploadResourceCreator
              v-if="$refs.fileResourceTab"
              :required="$refs.fileResourceTab.localActive && isRequired"
              :usedFor="usedFor"
              @set="setForm"
            />
          </b-card-text>
        </b-tab>
        <b-tab
          v-if="userData.is_superuser"
          :key="`${usedFor}-ftp-tab-${ftpKey}`"
          title="Charger depuis le FTP"
          ref="ftpResourceTab"
          @click="bdKey +=1; fileKey += 1; hrefKey += 1; isRequired = false"
        >
          <b-card-text>
            <FTPResourceCreator
              v-if="$refs.ftpResourceTab"
              :required="$refs.ftpResourceTab.localActive && isRequired"
              @set="setForm"
            />
          </b-card-text>
        </b-tab>
        <b-tab
          :key="`${usedFor}-url-tab-${hrefKey}`"
          title="Référencer une URL"
          ref="urlResourceTab"
          @click="bdKey +=1; fileKey += 1; ftpKey += 1; isRequired = false"
        >
          <b-card-text>
            <HrefResourceCreator
              v-if="$refs.urlResourceTab"
              :required="$refs.urlResourceTab.localActive && isRequired"
              @set="setForm"
            />
          </b-card-text>
        </b-tab>
      </b-tabs>
    </b-card>
    <div class="resource-form-header">
      <div class="form-row">
        <div class="form-group col-12">
          <label class="required">Nom</label>
          <ValidationProvider
            ref="display_name"
            :rules="isRequired ? 'required' : ''"
            :name="`Nom ${usedFor === 'resource' ? 'ressource' : 'annexe'}`"
            v-slot="{ classes, errors }"
          >
            <div class="control" :class="isRequired ? classes : ''">
              <input
                v-model="form.display_name"
                class="form-control"
                type="text"
                :placeholder="`Nom ${usedFor === 'resource' ? 'de la ressource' : ' de l\'annexe'}`"
              >
              <span class="form-errors">{{ errors[0] }}</span>
            </div>
          </ValidationProvider>
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-12">
          <label>Description</label>
          <textarea
            v-model="form.description"
            class="form-control"
          />
        </div>
      </div>
      <div class="form-row">
        <div class="form-group col-6">
          <label class="required">Type</label>
          <ValidationProvider
            ref="kind"
            :rules="isRequired ? 'required' : ''"
            :name="`Type ${usedFor}`"
            v-slot="{ classes, errors }"
          >
            <div class="control" :class="isRequired ? classes : ''">
              <Multiselect
                v-model="form.kind"
                :options="sortedKinds"
                :class="isRequired ? classes : ''"
                track-by="id"
                label="display_name"
                select-label=""
                selected-label=""
                deselect-label=""
                :searchable="false"
                placeholder="Sélectionner un type de ressource"
              />
              <span class="form-errors">{{ errors[0] }}</span>
            </div>
          </ValidationProvider>
        </div>
        <div class="form-group col-6">
          <label :class="usedFor === 'resource' ? 'required' : ''">
            Date de dernière mise à jour
          </label>
          <ValidationProvider
            ref="last_update_date"
            :rules="isRequired && usedFor === 'resource' ? 'required' : ''"
            :name="`Date de dernière mise à jour ${usedFor}`"
            v-slot="{ classes, errors }"
          >
            <div class="control" :class="isRequired && usedFor === 'resource' ? classes : ''">
              <input
                v-model="form.last_update_date"
                :class="{ empty: !form.last_update_date}"
                class="form-control"
                type="date"
              >
              <span class="form-errors">{{ errors[0] }}</span>
            </div>
          </ValidationProvider>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import BDResourceCreator from '@/components/ResourceCreators/BDResourceCreator.vue';
import FileUploadResourceCreator from '@/components/ResourceCreators/FileUploadResourceCreator.vue';
import FTPResourceCreator from '@/components/ResourceCreators/FTPResourceCreator.vue';
import HrefResourceCreator from '@/components/ResourceCreators/HrefResourceCreator.vue';
import Multiselect from 'vue-multiselect';

import { ValidationProvider, extend, configure, setInteractionMode } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});
setInteractionMode('passive');

export default {
  name: 'ResourceCreator',

  components: {
    BDResourceCreator,
    FileUploadResourceCreator,
    FTPResourceCreator,
    HrefResourceCreator,
    Multiselect,
    ValidationProvider
  },

  props: {
    usedFor: {
      type: String,
      default: 'resource'
    },
    required: {
      type: Boolean,
      default: true
    }
  },

  data() {
    return {
      bdKey: 1,
      fileKey: 1,
      ftpKey: 1,
      hrefKey: 1,
      isRequired: true,
      form: {
        display_name: null,
        description: null,
        kind: null,
        last_update_date: null
      },
      sortedKinds: []
    };
  },

  computed: {
    ...mapState('user-login', [
      'userData'
    ]),
    ...mapState('resources', [
      'resourceKinds'
    ])
  },

  watch: {
    required(newValue) {
      this.isRequired = newValue;
    },
    isRequired(newValue) {
      this.$emit('required', newValue);
    },
    form: {
      deep: true,
      handler(newValue) {
        if (newValue.display_name || newValue.description || newValue.kind) {
          this.isRequired = true;
        } else {
          this.isRequired = false;
        }
        this.$emit('set', {
          ...this.form,
          ...newValue
        });
      }
    }
  },

  created() {
    this.isRequired = this.required;
    if (this.resourceKinds.length === 0) {
      this.GET_RESOURCE_KINDS()
        .then(() => {
          this.sortedKinds = this.resourceKinds.sort((a, b) => a.display_name.localeCompare(b.display_name));
        });
    } else {
      this.sortedKinds = this.resourceKinds.sort((a, b) => a.display_name.localeCompare(b.display_name));
    }
  },

  mounted() {
    this.bdKey += 1;
    this.fileKey += 1;
    this.ftpKey += 1;
    this.hrefKey += 1;
  },

  methods: {
    ...mapActions('resources', [
      'GET_RESOURCE_KINDS'
    ]),

    setRequired(e) {
      this.isRequired = e;
    },

    setForm(e) {
      this.isRequired = e.required;
      if (e.form) {
        this.form = {
          ...this.form,
          ...e.form
        };
        this.$emit('set', this.form);
      }
    },
  }
}
</script>

<style lang="less" scoped>

.resource-form-container {
  box-shadow: 0 0 1px 1px #ccc;
  padding-bottom: 1.5rem;
}

.resource-form-header {
  border-radius: 0.25rem;
  border-bottom: none;
  border-top: none;
  border-radius: 0;
  padding: 1em 1em 0;
}

.form-row {
  margin-right: 1em;
}

.card {
  border-radius: 0;
  border: none;
}

</style>
